﻿@page
@using Management.Entities;
@using Management.BusinessLogic;
@model Management.Pages.category.EditModel
@{
    /* Constants */
    ViewData["Title"] = "Edit Category";

    /* Default value */
    string sInfo = string.Empty;
    bool bFlag = false;
    Category category = new Category() {};

    /* Get category id */
    string sCategoryID = Request.Query["id"];

    /* Read category detail */
    Category? isCategory = BUS_Category.ReadInfo(sCategoryID);

    if (null == isCategory)
    {
        sInfo = "This category is not exists";
        bFlag = true;
    }
    else
    {
        /* Get category */
        category = isCategory.Value;

        if (Request.Method == "POST")
        {
            /* Set a flag to indicate the user posted the form */
            bFlag = true;

            /* Get new category attributes */
            string sID = Request.Form["id"];
            string sName = Request.Form["name"];

            /* Returns an empty string in case the new category is successfully added */
            sInfo = BUS_Category.Edit(sID, sName, ref category);
        }
    }
}

<div class="row text-start">
    <p>
        <a href="/" class="link-primary text-decoration-none">Home</a>
        >
        <a href="/category" class="link-primary text-decoration-none">Category</a>
        >
        <a href="/category/delete?id=@sCategoryID" class="link-primary text-decoration-none">Edit</a>
    </p>
</div>
<div class="border border-secondary rounded px-3 mb-3">
    <div class="row pt-2">
        <p class="col-sm-6 text-start fw-bold">Category attributes</p>
        @if (bFlag)
        {
            if (string.IsNullOrEmpty(sInfo))
            {
                <p class="col-sm-6 text-end text-success fw-bold">Edited category successfully</p>
            }
            else
            {
                <p class="col-sm-6 text-end text-danger fw-bold">@sInfo</p>
            }
        }
    </div>

    <form class="row g-3 mb-2" method="post">
        <div class="col-md-4">
            <label for="id" class="form-label">Category ID</label>
            <input class="form-control" type="text" id="id" name="id" value="@category.ID" placeholder="Category ID" maxlength="30" required>
        </div>
        <div class="col-md-4">
            <label for="name" class="form-label">Category Name</label>
            <input class="form-control" type="text" id="name" name="name" value="@category.Name" placeholder="Category Name" maxlength="30" required>
        </div>
        <div class="col-md-4 d-sm-flex align-items-end justify-content-end pb-1">
            <input class="btn btn-sm btn-warning text-light" type="submit" value="Edit">
        </div>
    </form>
</div>

<div class="border border-secondary rounded px-3 mb-3">
    <div class="row pt-2">
        <p class="text-start fw-bold">Current category attributes</p>
    </div>
    <div class="text-center table_section">

        <table class="table table-bordered table-striped table-hover align-middle">
            <thead>
                <tr>
                    <th>Category ID</th>
                    <th>Category Name</th>
                </tr>
            </thead>

            <tbody>
                <tr>
                    <td>@category.ID</td>
                    <td>@category.Name</td>
                </tr>
            </tbody>
        </table>
    </div>
</div>

